package com.jiuqi.db.impl;

import com.jiuqi.util.DateUtil;
import java.util.Date;
import com.jiuqi.db.DBFunction;

public class SQLServerDBFunction extends DBFunction
{
    private static final String STR_LINK_SYMBOL = "+";
    private static final String FUNC_NAME_CEILING = "CEILING";
    private static final String FUNC_NAME_LN = "LOG";
    private static final String FUNC_NAME_LOG10 = "LOG10";
    private static final String FUNC_NAME_CHR = "CHAR";
    private static final String FUNC_NAME_POS = "CHARINDEX";
    private static final String FUNC_NAME_LEFT = "LEFT";
    private static final String FUNC_NAME_RIGHT = "RIGHT";
    private static final String FUNC_NAME_SUBSTR = "SUBSTRING";
    private static final String FUNC_NAME_LEN = "DATALENGTH";
    private static final String FUNC_NAME_MOD = "%";
    private static final String FUNC_NAME_STR = "CAST";
    private static final String FUNC_NAME_VAL = "CAST";
    
    public String strLinkSymbol() {
        return "+";
    }
    
    public boolean supportEmptyString() {
        return true;
    }
    
    public String ceiling(final String numeric_expression) {
        return this.format("CEILING", numeric_expression);
    }
    
    public String ln(final String numeric_expression) {
        return this.format("LOG", numeric_expression);
    }
    
    public String log10(final String numeric_expression) {
        return this.format("LOG10", numeric_expression);
    }
    
    public String mod(final String numeric_expression1, final String numeric_expression2) {
        return this.formatmidopt(numeric_expression1, "%", numeric_expression2);
    }
    
    public String chr(final String int_expression) {
        return this.format("CHAR", int_expression);
    }
    
    public String pos(final String substr_expression, final String str_expression) {
        return this.format("CHARINDEX", substr_expression, str_expression);
    }
    
    public String left(final String str_expression, final String length_expression) {
        return this.format("LEFT", str_expression, length_expression);
    }
    
    public String right(final String str_expression, final String length_expression) {
        return this.format("RIGHT", str_expression, length_expression);
    }
    
    public String str(final String numeric_expression) {
        return this.format("CAST", String.valueOf(numeric_expression) + " AS VARCHAR(50)");
    }
    
    public String substr(final String str_expression, final String from_expression, final String length_expression) {
        return this.format("SUBSTRING", str_expression, from_expression, length_expression);
    }
    
    public String len(final String str_expression) {
        return this.format("DATALENGTH", str_expression);
    }
    
    public String val(final String str_expression) {
        return this.format("CAST", String.valueOf(str_expression) + " AS FLOAT");
    }
    
    public String date(final Date dateVal) {
        return "'" + DateUtil.convertDateToString1(dateVal) + "'";
    }
}
